package apis

import (
    "fmt"

	"github.com/gin-gonic/gin"
	"github.com/go-admin-team/go-admin-core/sdk/api"
	"github.com/go-admin-team/go-admin-core/sdk/pkg/jwtauth/user"
	_ "github.com/go-admin-team/go-admin-core/sdk/pkg/response"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
)

type VtsRecharge struct {
	api.Api
}

// GetPage 获取coinGate充值记录表列表
// @Summary 获取coinGate充值记录表列表
// @Description 获取coinGate充值记录表列表
// @Tags coinGate充值记录表
// @Param coinCode query string false "币种"
// @Param orderNo query string false "订单号"
// @Param adUserId query int64 false "用户id"
// @Param pageSize query int false "页条数"
// @Param pageIndex query int false "页码"
// @Success 200 {object} response.Response{data=response.Page{list=[]models.VtsRecharge}} "{"code": 200, "data": [...]}"
// @Router /api/v1/vts-recharge [get]
// @Security Bearer
func (e VtsRecharge) GetPage(c *gin.Context) {
    req := dto.VtsRechargeGetPageReq{}
    s := service.VtsRecharge{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
   	if err != nil {
   		e.Logger.Error(err)
   		e.Error(500, err, err.Error())
   		return
   	}

	p := actions.GetPermissionFromContext(c)
	list := make([]models.VtsRecharge, 0)
	var count int64

	err = s.GetPage(&req, p, &list, &count)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取coinGate充值记录表失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.PageOK(list, int(count), req.GetPageIndex(), req.GetPageSize(), "查询成功")
}

// Get 获取coinGate充值记录表
// @Summary 获取coinGate充值记录表
// @Description 获取coinGate充值记录表
// @Tags coinGate充值记录表
// @Param id path int false "id"
// @Success 200 {object} response.Response{data=models.VtsRecharge} "{"code": 200, "data": [...]}"
// @Router /api/v1/vts-recharge/{id} [get]
// @Security Bearer
func (e VtsRecharge) Get(c *gin.Context) {
	req := dto.VtsRechargeGetReq{}
	s := service.VtsRecharge{}
    err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	var object models.VtsRecharge

	p := actions.GetPermissionFromContext(c)
	err = s.Get(&req, p, &object)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取coinGate充值记录表失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK( object, "查询成功")
}

// Insert 创建coinGate充值记录表
// @Summary 创建coinGate充值记录表
// @Description 创建coinGate充值记录表
// @Tags coinGate充值记录表
// @Accept application/json
// @Product application/json
// @Param data body dto.VtsRechargeInsertReq true "data"
// @Success 200 {object} response.Response	"{"code": 200, "message": "添加成功"}"
// @Router /api/v1/vts-recharge [post]
// @Security Bearer
func (e VtsRecharge) Insert(c *gin.Context) {
    req := dto.VtsRechargeInsertReq{}
    s := service.VtsRecharge{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	// 设置创建人
	req.SetCreateBy(user.GetUserId(c))

	err = s.Insert(&req)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("创建coinGate充值记录表失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK(req.GetId(), "创建成功")
}

// Update 修改coinGate充值记录表
// @Summary 修改coinGate充值记录表
// @Description 修改coinGate充值记录表
// @Tags coinGate充值记录表
// @Accept application/json
// @Product application/json
// @Param id path int true "id"
// @Param data body dto.VtsRechargeUpdateReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "修改成功"}"
// @Router /api/v1/vts-recharge/{id} [put]
// @Security Bearer
func (e VtsRecharge) Update(c *gin.Context) {
    req := dto.VtsRechargeUpdateReq{}
    s := service.VtsRecharge{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Update(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("修改coinGate充值记录表失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "修改成功")
}

// Delete 删除coinGate充值记录表
// @Summary 删除coinGate充值记录表
// @Description 删除coinGate充值记录表
// @Tags coinGate充值记录表
// @Param data body dto.VtsRechargeDeleteReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "删除成功"}"
// @Router /api/v1/vts-recharge [delete]
// @Security Bearer
func (e VtsRecharge) Delete(c *gin.Context) {
    s := service.VtsRecharge{}
    req := dto.VtsRechargeDeleteReq{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }

	// req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Remove(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("删除coinGate充值记录表失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "删除成功")
}
